var ScreenCompanionDebugConsole = function()
{
    var self = this;
    var containerDiv = null;
    var clearButtonDiv = null;
    var messagesListDiv = null;

    var init = function()
    {
        containerDiv = document.getElementById("scDebugConsoleContainer");
        messagesListDiv = document.getElementById("scDebugConsoleMessages");
        clearButtonDiv = document.getElementById("scDebugConsoleClearButton");
        clearButtonDiv.addEventListener("click", function(){ messagesListDiv.innerHTML = ""; });
        document.getElementById("scDebugConsoleAddFakeEntryButton").addEventListener("click", function(){ self.addLogMessageHTML("user agent: " + navigator.userAgent); });
        document.getElementById("scDebugConsoleScrollToBottomButton").addEventListener("click", function(){ messagesListDiv.parentNode.scrollTop = messagesListDiv.parentNode.scrollHeight; });
        document.getElementById("scDebugConsoleScrollToTopButton").addEventListener("click", function(){ messagesListDiv.parentNode.scrollTop = 0; });
        document.getElementById("scDebugConsoleScrollDownButton").addEventListener("click", function(){ messagesListDiv.parentNode.scrollTop += 12; });
        document.getElementById("scDebugConsoleScrollUpButton").addEventListener("click", function(){ messagesListDiv.parentNode.scrollTop -= 12; });
        // 
    }

    this.addLogMessageHTML = function(htmlMsg)
    {
        var msgLine = document.createElement("DIV");
        msgLine.innerHTML = htmlMsg;
        msgLine.className = "scDebugConsoleMessageLine";
        messagesListDiv.appendChild(msgLine);
        //msgLine.scrollIntoView(); /* scrolldown */
        messagesListDiv.parentNode.scrollTop = messagesListDiv.parentNode.scrollHeight;
    }

    this.refreshView = function()
    {
        // scroll down
        messagesListDiv.parentNode.scrollTop = messagesListDiv.parentNode.scrollHeight;
    }

    init.call(self);
}