var ScreenCompanionSettings = function(sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    
    var rotationPrevButton = null;
    var rotationNextButton = null;
    var rotationValueDiv = null;

    var vignettingPrevButton = null;
    var vignettingNextButton = null;
    var vignettingValueDiv = null;

    var musicVolLessButton = null;
    var musicVolMoreButton = null;
    var musicVolValueDiv = null;

    var voicesVolLessButton = null;
    var voicesVolMoreButton = null;
    var voicesVolValueDiv = null;
    
    var microphoneOffButton = null;
    var microphoneOnButton = null;
    var microphoneValueDiv = null;



    var init = function()
    {
        containerDiv = document.getElementById("scSettingsContainer");
        
        rotationPrevButton = containerDiv.querySelector("#scSettingsRotationPrevButton");
        rotationPrevButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "RotationPrev", [rotationValueDiv.textContent]);}  });
        rotationNextButton = containerDiv.querySelector("#scSettingsRotationNextButton");
        rotationNextButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "RotationNext", [rotationValueDiv.textContent]);}  });
        rotationValueDiv = containerDiv.querySelector("#scSettingsRotationValue");
        rotationValueDiv.textContent = "90°";

        vignettingPrevButton = containerDiv.querySelector("#scSettingsVignettingPrevButton");
        vignettingPrevButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "VignettingPrev", [vignettingValueDiv.textContent]);}  });
        vignettingNextButton = containerDiv.querySelector("#scSettingsVignettingNextButton");
        vignettingNextButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "VignettingNext", [vignettingValueDiv.textContent]);}  });
        vignettingValueDiv = containerDiv.querySelector("#scSettingsVignettingValue");
        vignettingValueDiv.textContent = "Medium";

        musicVolLessButton = containerDiv.querySelector("#scSettingsMusicVolLessButton");
        musicVolLessButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "MusicVolumeLess", [musicVolValueDiv.textContent]);}  });
        musicVolMoreButton = containerDiv.querySelector("#scSettingsMusicVolMoreButton");
        musicVolMoreButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "MusicVolumeMore", [musicVolValueDiv.textContent]);}  });
        musicVolValueDiv = containerDiv.querySelector("#scSettingsMusicVolValue");
        musicVolValueDiv.textContent = "6";

        voicesVolLessButton = containerDiv.querySelector("#scSettingsVoicesVolLessButton");
        voicesVolLessButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "VoicesVolumeLess", [voicesVolValueDiv.textContent]);}  });
        voicesVolMoreButton = containerDiv.querySelector("#scSettingsVoicesVolMoreButton");
        voicesVolMoreButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "VoicesVolumeMore", [voicesVolValueDiv.textContent]);}  });
        voicesVolValueDiv = containerDiv.querySelector("#scSettingsVoicesVolValue");
        voicesVolValueDiv.textContent = "7";
        
        microphoneOffButton = containerDiv.querySelector("#scSettingsMicrophoneOffButton");
        microphoneOffButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "MicrophonePrev", [microphoneValueDiv.textContent]);}  });
        microphoneOnButton = containerDiv.querySelector("#scSettingsMicrophoneOnButton");
        microphoneOnButton.addEventListener("click", function(){  if(sendMessageAction != null){ sendMessageAction("Settings", "MicrophoneNext", [microphoneValueDiv.textContent]);}  });
        microphoneValueDiv = containerDiv.querySelector("#scSettingsMicrophoneValue");
        microphoneValueDiv.textContent = "On";
    }

    this.setDataAll = function(dataset)
    {
        rotationValueDiv.textContent = dataset[0];
        vignettingValueDiv.textContent = dataset[1];
        musicVolValueDiv.textContent = dataset[2];
        voicesVolValueDiv.textContent = dataset[3];
        microphoneValueDiv.textContent = dataset[4];
    }

    init.call(self);
}