/*
This class manage tabs and their associated panels visibility
*/
var ScreenCompanionTabs = function(onPanelSelectedAction){
    var self = this;
    var containerDiv = null;
    var tabNames = ["Game", "Account", "Inventory", "Teammates", "Settings", "Help", "Developer", "Console"];
    
    var tabsDivs = {}; // populated in init()
    var panelsDivs = {};

    var defaultSelectedTabIdx = 0; // console as default during development
    var selectedTabIdx = -1;

    var init = function()
    {
        //prevButtonDiv.addEventListener("click", function(){ prevButtonClicked.call(self); });
        for(var i = 0; i< tabNames.length; i++)
        {
            var tName = tabNames[i];
            tabsDivs[tName] = document.getElementById("scTab"+tName);
            tabsDivs[tName].addEventListener("click", (function(idx) { return function(){ selectTabAtIndex.call(self, idx); }  } )(i+0) );
            panelsDivs[tName] = document.getElementById("scPanel"+tName);
        }

        selectTabAtIndex(defaultSelectedTabIdx);
        //console.log(tabsDivs);
        //console.log(panelsDivs);
    }

    /*
    var prevButtonClicked = function()
    {
        if(selectedTabIdx > 0)
            selectTabAtIndex(selectedTabIdx-1);
    }
    */
    
    var selectTabAtIndex = function(idx)
    {
        //console.log(idx);
        for(var i = 0; i< tabNames.length; i++)
        {
            var tName = tabNames[i];
            tabsDivs[tName].className = idx==i ? "scTabSelected" : "scTab";
            panelsDivs[tName].style.display = idx==i ? null : 'none';
        }

        selectedTabIdx = idx;
        
        if(onPanelSelectedAction != null)
            onPanelSelectedAction(tabNames[selectedTabIdx]);
    }

    init.call(self);
}