var ScreenCompanionTeammates = function(sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    var loadingOverlayDiv = null;
    var pageLessButton = null;
    var pageMoreButton = null;
    var currentPageDiv = null;
    var totalPagesDiv = null;

    var teammates = [];

    var init = function()
    {
        containerDiv = document.getElementById("scTeammatesContainer");
        loadingOverlayDiv = containerDiv.querySelector(".loadingOverlay");
        pageLessButton = containerDiv.querySelector("#scTeammatesPageLessButton");
        pageLessButton.addEventListener("click", function(){  if(sendMessageAction != null){ self.showLoading(); sendMessageAction("Teammates", "GetPage", [(parseInt(currentPageDiv.textContent)-1)] );}  });
        pageMoreButton = containerDiv.querySelector("#scTeammatesPageMoreButton");
        pageMoreButton.addEventListener("click", function(){  if(sendMessageAction != null){ self.showLoading(); sendMessageAction("Teammates", "GetPage", [(parseInt(currentPageDiv.textContent)+1)] );}  });
        currentPageDiv = containerDiv.querySelector("#scTeammatesCurrentPageButton");
        totalPagesDiv = containerDiv.querySelector("#scTeammatesTotalPagesButton");
        
        for(var i=0; i<8; i++)
        {
            teammates.push(new ScreenCompanionTeammate(i, containerDiv, sendMessageAction));
        }
        
        this.reset();
    }

    this.reset = function()
    {
        currentPageDiv.textContent = 0;
        totalPagesDiv.textContent = 0;
        for(var i=0; i<8; i++)
        {
            teammates[i].reset();
        }
    }

    this.showLoading = function()
    {
        loadingOverlayDiv.style.display = "";
    }

    this.hideLoading = function()
    {
        loadingOverlayDiv.style.display = "none";
    }

    this.setPageData = function(dataset)
    {
        this.reset();
        currentPageDiv.textContent = dataset[0];
        totalPagesDiv.textContent = dataset[1];
        for(var i=2; i<dataset.length; i++)
        {
            teammates[i-2].setData(dataset[i].split("]¤["));
        }
        
        self.hideLoading();
    }

    init.call(self);
}


var ScreenCompanionTeammate = function(idxInListView, parentContainerDiv, sendMessageAction)
{
    var self = this;
    var containerDiv = null;
    var usernameDiv = null;
    var statusDiv = null;
    var inviteButton = null;
    var acceptButton = null;
    var rejectButton = null;
    var joinButton = null;

    var init = function()
    {
        containerDiv = parentContainerDiv.querySelector("#scTeammate"+idxInListView+"Container");
        usernameDiv = containerDiv.querySelector("#scTeammate"+idxInListView+"Username");
        statusDiv = containerDiv.querySelector("#scTeammate"+idxInListView+"Status");
        inviteButton = containerDiv.querySelector("#scTeammate"+idxInListView+"InviteButton");
        inviteButton.addEventListener("click", function(){  if(sendMessageAction != null){ console.log("invite", containerDiv.getAttribute("data-user-id")); sendMessageAction("system-check", "ping", "to C#");}  });
        acceptButton = containerDiv.querySelector("#scTeammate"+idxInListView+"AcceptButton");
        acceptButton.addEventListener("click", function(){  if(sendMessageAction != null){ console.log("accept", containerDiv.getAttribute("data-user-id")); sendMessageAction("system-check", "ping", "to C#");}  });
        rejectButton = containerDiv.querySelector("#scTeammate"+idxInListView+"RejectButton");
        rejectButton.addEventListener("click", function(){  if(sendMessageAction != null){ console.log("reject", containerDiv.getAttribute("data-user-id")); sendMessageAction("system-check", "ping", "to C#");}  });
        joinButton = containerDiv.querySelector("#scTeammate"+idxInListView+"JoinButton");
        joinButton.addEventListener("click", function(){  if(sendMessageAction != null){ console.log("join", containerDiv.getAttribute("data-user-id")); sendMessageAction("system-check", "ping", "to C#");}  });
    }

    this.reset = function()
    {
        containerDiv.setAttribute("data-user-id", -1);
        containerDiv.className = "";
        usernameDiv.textContent = "";
        statusDiv.textContent = "";
        inviteButton.style.display = "none";
        acceptButton.style.display = "none";
        rejectButton.style.display = "none";
        joinButton.style.display = "none";
    }

    this.setData = function(dataset)
    {
        
        containerDiv.setAttribute("data-user-id", dataset[0]);
        containerDiv.className = "underlineCells";
        usernameDiv.textContent = dataset[1];
        statusDiv.textContent = dataset[2];
        switch(dataset[3])
        {
            case "pending":
                acceptButton.style.display = "";
                break;
            case "joinable":
                joinButton.style.display = "";
                break;
            case "invite":
                inviteButton.style.display = "";
                break;
        }
        /* as of 2022-01-27 (pre-beta) the reject button is not in use */
        // rejectButton.style.display = "none";

    }

    init.call(self);
}