var Ankaa = Ankaa || {};
Ankaa.Client = Ankaa.Client || {};
Ankaa.Client.TheatreScreen = Ankaa.Client.TheatreScreen || {};

Ankaa.Client.TheatreScreen.CommunicationAPI = function(sendMessageToEngineFunc)
{
    if(Ankaa.Client.TheatreScreen.__CommunicationAPI_instance != null)
    {
        return Ankaa.Client.TheatreScreen.__CommunicationAPI_instance;
    }


    var self = this;
    
    var sendMessageFunc = null;

    var messageReceivedFromJSEngineFunc = null;

    var init = function()
    {
        // singleton
        Ankaa.Client.TheatreScreen.__CommunicationAPI_instance = self;
        
        sendMessageFunc = sendMessageToEngineFunc;

        console.log("Ankaa.Client.TheatreScreen.CommunicationAPI initialized");
    }

    self.setJSEngineMessageListenerFunc = function(funcMethod)
    {
        messageReceivedFromJSEngineFunc = funcMethod;
    }

    self.sendMessage = function(action, parameters)
    {
        sendMessageFunc("theatre-to-JSEngine", action, parameters);
    }

    self.processMessage = function(msg)
    {

        console.log("message to publish");
        console.log(JSON.stringify(msg));
        if(msg["category"] == "JSEngine-to-theatre")
        {
            if(msg["action"] == "force-page-reload")
            {
                document.location.reload(true);
            }
            else if(messageReceivedFromJSEngineFunc != null)
            {
                try
                {
                    messageReceivedFromJSEngineFunc(msg["action"], msg["parameters"]);
                }catch(e1)
                {
                    console.log("EXCEPTION: exception in theatre screen script: " + e1.message + "\n" + e1.stack );
                }
                
            }
        }
            
        
    }

    self.getInfo = function()
    {
        return "This is the main library used to access the VR world from the embedded webpages.";
    }


    self.delayedCall = function(funcToCall, delayMs)
    {
        (async function() { 
            try
            {
                if(navigator.userAgent.indexOf('AnkaaHeadless')>-1)
                    await Task.Delay(delayMs); 
                else
                    await new Promise(r => setTimeout(r, delayMs));

                funcToCall();    
            }
            catch(e1)
            {
                console.log(e1.message);
                console.log(e1.stack);
            }
        })();
    }

    init.call(self);
}