var Ankaa = Ankaa || {};
Ankaa.Client = Ankaa.Client || {};
Ankaa.Client.TheatreScreen = Ankaa.Client.TheatreScreen || {};

Ankaa.Client.TheatreScreen.KickstartScreen = function(win)
{
    var self = this;

    var isVuplexAvailable = null;
    
    var init = function()
    {
        //console.log('Ankaa.Client.TheatreScreen.KickstartScreen enter init');
        //console.log('Ankaa.Client.TheatreScreen.KickstartScreen url is: ' + document.location.href);
        //console.log('Ankaa.Client.TheatreScreen.KickstartScreen userAgent is: ' + navigator.userAgent);
        // we are here because onDomLoaded has been triggered 
        // if we are in VR, the url contains ?waitVuplex=1 and we must wait that window.vuplex becomes available
        // on real PC/Mac webbrowser we don't need vuplex because we simulate VR communication using GameSimulatorToolkit
        initDelayed();
    }

    var initDelayed = function(){
        try
        {
            var initialized = false;
            
            isVuplexAvailable = typeof(globalThis.vuplex) != 'undefined';
            if(isVuplexAvailable)
            {
                initializeKickstart();
                globalThis.vuplex.addEventListener('message', function(evt){ 
                    //console.log('Ankaa.Client.JSEngine.Kickstart enter message from host event listener'); 
                    onMessageReceived.call(self, JSON.parse(evt.data)); 
                })
                self.sendMessage('ready', '', '');
                initialized = true;
            }
            else
            {
                setTimeout(function(){ initDelayed() }, 200); // retry in 200ms
            }
            
            console.log('Ankaa.Client.TheatreScreen.KickstartScreen loaded');
            
            /*
            if(typeof(globalThis.VRScriptAutoLoad) != "undefined")
            {
                console.log('Ankaa.Client.TheatreScreen.KickstartScreen have found an VRScriptAutoLoad method');
                globalThis.__VRScriptAutoLoad = new globalThis.VRScriptAutoLoad(globalThis);
            }*/
            // The user is responsible to load his script using the document "DOMContentLoaded" event
        }
        catch(e1)
        {
            console.log('Ankaa.Client.TheatreScreen.KickstartScreen exception: '+e1.message+'\n'+e1.stack);
        }
        
    }

    var onMessageReceived = function(msg)
    {
        try
        {
            //console.log(JSON.parse(msg));
            if(msg['category'] == 'dummy-js-code'/* && msg['action'] == 'pong'*/)
            {
                console.log('JS side received a pong from C#');
                document.body.innerHTML += '<br/>' + JSON.stringify(msg);
            }
            else if(msg["category"] == "debug-console" && msg["action"] == "execute-instruction")
            {
                //console.log("JSEngineScreen received a JS command: " + msg["parameters"][0]);
                console.log(">>> " + msg["parameters"][0]);
                eval(msg["parameters"][0]);
            }
            else
            {
                globalThis.$VR.processMessage(msg);
            }
        }
        catch(e1)
        {
            console.log('Ankaa.Client.TheatreScreen.KickstartScreen JS exception in onMessageReceived method: '+e1.message+'\n'+e1.stack);
        }

        
    }
    
    var sendRawMessage = function(json)
    {
        // if vuplex exists
        if(isVuplexAvailable)
        {
            globalThis.vuplex.postMessage(json);
        }
        else if(navigator.userAgent.indexOf('AnkaaHeadless')>-1)
        {
            host.messageToHost(json);
        }
        else
        {
            console.log('should send message to c#:', json);
        }
    }

    self.sendMessage = function(category, action, parameters, id = "-", responseFor = "-")
    {
        sendRawMessage(JSON.stringify({'category': category, 'action': action, 'parameters': parameters, 'id': id, 'responseFor': responseFor}));
    }
    
    var initializeKickstart = function()
    {
        globalThis.$VR = new Ankaa.Client.TheatreScreen.CommunicationAPI(
            (function(){ return function(category, action, parameters, id, reponseFor){ self.sendMessage.call(self, category, action, parameters, id, reponseFor); }; })()
        );
    }

    init.call(self);
}


window.__KickstartScreen = new Ankaa.Client.TheatreScreen.KickstartScreen(window);